// Code generated by msgraph-generate.go DO NOT EDIT.

package msgraph

// AndroidEasEmailProfileConfiguration By providing configurations in this profile you can instruct the native email client on KNOX devices to communicate with an Exchange server and get email, contacts, calendar, tasks, and notes. Furthermore, you can also specify how much email to sync and how often the device should sync.
type AndroidEasEmailProfileConfiguration struct {
	// DeviceConfiguration is the base model of AndroidEasEmailProfileConfiguration
	DeviceConfiguration
	// AccountName Exchange ActiveSync account name, displayed to users as name of EAS (this) profile.
	AccountName *string `json:"accountName,omitempty"`
	// AuthenticationMethod Authentication method for Exchange ActiveSync.
	AuthenticationMethod *EasAuthenticationMethod `json:"authenticationMethod,omitempty"`
	// SyncCalendar Toggles syncing the calendar. If set to false calendar is turned off on the device.
	SyncCalendar *bool `json:"syncCalendar,omitempty"`
	// SyncContacts Toggles syncing contacts. If set to false contacts are turned off on the device.
	SyncContacts *bool `json:"syncContacts,omitempty"`
	// SyncTasks Toggles syncing tasks. If set to false tasks are turned off on the device.
	SyncTasks *bool `json:"syncTasks,omitempty"`
	// SyncNotes Toggles syncing notes. If set to false notes are turned off on the device.
	SyncNotes *bool `json:"syncNotes,omitempty"`
	// DurationOfEmailToSync Duration of time email should be synced to.
	DurationOfEmailToSync *EmailSyncDuration `json:"durationOfEmailToSync,omitempty"`
	// EmailAddressSource Email attribute that is picked from AAD and injected into this profile before installing on the device.
	EmailAddressSource *UserEmailSource `json:"emailAddressSource,omitempty"`
	// EmailSyncSchedule Email sync schedule.
	EmailSyncSchedule *EmailSyncSchedule `json:"emailSyncSchedule,omitempty"`
	// HostName Exchange location (URL) that the native mail app connects to.
	HostName *string `json:"hostName,omitempty"`
	// RequireSmime Indicates whether or not to use S/MIME certificate.
	RequireSmime *bool `json:"requireSmime,omitempty"`
	// RequireSsl Indicates whether or not to use SSL.
	RequireSsl *bool `json:"requireSsl,omitempty"`
	// UsernameSource Username attribute that is picked from AAD and injected into this profile before installing on the device.
	UsernameSource *AndroidUsernameSource `json:"usernameSource,omitempty"`
	// UserDomainNameSource UserDomainname attribute that is picked from AAD and injected into this profile before installing on the device.
	UserDomainNameSource *DomainNameSource `json:"userDomainNameSource,omitempty"`
	// CustomDomainName Custom domain name value used while generating an email profile before installing on the device.
	CustomDomainName *string `json:"customDomainName,omitempty"`
	// IdentityCertificate undocumented
	IdentityCertificate *AndroidCertificateProfileBase `json:"identityCertificate,omitempty"`
	// SmimeSigningCertificate undocumented
	SmimeSigningCertificate *AndroidCertificateProfileBase `json:"smimeSigningCertificate,omitempty"`
}
