// Code generated by msgraph-generate.go DO NOT EDIT.

package msgraph

// AppleVpnConfiguration Apple VPN configuration profile.
type AppleVpnConfiguration struct {
	// DeviceConfiguration is the base model of AppleVpnConfiguration
	DeviceConfiguration
	// ConnectionName Connection name displayed to the user.
	ConnectionName *string `json:"connectionName,omitempty"`
	// ConnectionType Connection type.
	ConnectionType *AppleVpnConnectionType `json:"connectionType,omitempty"`
	// LoginGroupOrDomain Login group or domain when connection type is set to Dell SonicWALL Mobile Connection.
	LoginGroupOrDomain *string `json:"loginGroupOrDomain,omitempty"`
	// Role Role when connection type is set to Pulse Secure.
	Role *string `json:"role,omitempty"`
	// Realm Realm when connection type is set to Pulse Secure.
	Realm *string `json:"realm,omitempty"`
	// Server VPN Server on the network. Make sure end users can access this network location.
	Server *VpnServer `json:"server,omitempty"`
	// Identifier Identifier provided by VPN vendor when connection type is set to Custom VPN. For example: Cisco AnyConnect uses an identifier of the form com.cisco.anyconnect.applevpn.plugin
	Identifier *string `json:"identifier,omitempty"`
	// CustomData Custom data when connection type is set to Custom VPN. Use this field to enable functionality not supported by Intune, but available in your VPN solution. Contact your VPN vendor to learn how to add these key/value pairs. This collection can contain a maximum of 25 elements.
	CustomData []KeyValue `json:"customData,omitempty"`
	// CustomKeyValueData Custom data when connection type is set to Custom VPN. Use this field to enable functionality not supported by Intune, but available in your VPN solution. Contact your VPN vendor to learn how to add these key/value pairs. This collection can contain a maximum of 25 elements.
	CustomKeyValueData []KeyValuePair `json:"customKeyValueData,omitempty"`
	// EnableSplitTunneling Send all network traffic through VPN.
	EnableSplitTunneling *bool `json:"enableSplitTunneling,omitempty"`
	// AuthenticationMethod Authentication method for this VPN connection.
	AuthenticationMethod *VpnAuthenticationMethod `json:"authenticationMethod,omitempty"`
	// EnablePerApp Setting this to true creates Per-App VPN payload which can later be associated with Apps that can trigger this VPN conneciton on the end user's iOS device.
	EnablePerApp *bool `json:"enablePerApp,omitempty"`
	// SafariDomains Safari domains when this VPN per App setting is enabled. In addition to the apps associated with this VPN, Safari domains specified here will also be able to trigger this VPN connection.
	SafariDomains []string `json:"safariDomains,omitempty"`
	// OnDemandRules On-Demand Rules. This collection can contain a maximum of 500 elements.
	OnDemandRules []VpnOnDemandRule `json:"onDemandRules,omitempty"`
	// ProxyServer Proxy Server.
	ProxyServer *VpnProxyServer `json:"proxyServer,omitempty"`
	// OptInToDeviceIDSharing Opt-In to sharing the device's Id to third-party vpn clients for use during network access control validation.
	OptInToDeviceIDSharing *bool `json:"optInToDeviceIdSharing,omitempty"`
}
