// Code generated by msgraph-generate.go DO NOT EDIT.

package msgraph

import "time"

// DepOnboardingSetting The depOnboardingSetting represents an instance of the Apple DEP service being onboarded to Intune. The onboarded service instance manages an Apple Token used to synchronize data between Apple and Intune.
type DepOnboardingSetting struct {
	// Entity is the base model of DepOnboardingSetting
	Entity
	// AppleIdentifier The Apple ID used to obtain the current token.
	AppleIdentifier *string `json:"appleIdentifier,omitempty"`
	// TokenExpirationDateTime When the token will expire.
	TokenExpirationDateTime *time.Time `json:"tokenExpirationDateTime,omitempty"`
	// LastModifiedDateTime When the service was onboarded.
	LastModifiedDateTime *time.Time `json:"lastModifiedDateTime,omitempty"`
	// LastSuccessfulSyncDateTime When the service last syned with Intune
	LastSuccessfulSyncDateTime *time.Time `json:"lastSuccessfulSyncDateTime,omitempty"`
	// LastSyncTriggeredDateTime When Intune last requested a sync.
	LastSyncTriggeredDateTime *time.Time `json:"lastSyncTriggeredDateTime,omitempty"`
	// ShareTokenWithSchoolDataSyncService Whether or not the Dep token sharing is enabled with the School Data Sync service.
	ShareTokenWithSchoolDataSyncService *bool `json:"shareTokenWithSchoolDataSyncService,omitempty"`
	// LastSyncErrorCode Error code reported by Apple during last dep sync.
	LastSyncErrorCode *int `json:"lastSyncErrorCode,omitempty"`
	// TokenType Gets or sets the Dep Token Type.
	TokenType *DepTokenType `json:"tokenType,omitempty"`
	// TokenName Friendly Name for Dep Token
	TokenName *string `json:"tokenName,omitempty"`
	// SyncedDeviceCount Gets synced device count
	SyncedDeviceCount *int `json:"syncedDeviceCount,omitempty"`
	// DataSharingConsentGranted Consent granted for data sharing with Apple Dep Service
	DataSharingConsentGranted *bool `json:"dataSharingConsentGranted,omitempty"`
	// RoleScopeTagIDs List of Scope Tags for this Entity instance.
	RoleScopeTagIDs []string `json:"roleScopeTagIds,omitempty"`
	// DefaultIOSEnrollmentProfile undocumented
	DefaultIOSEnrollmentProfile *DepIOSEnrollmentProfile `json:"defaultIosEnrollmentProfile,omitempty"`
	// DefaultMacOsEnrollmentProfile undocumented
	DefaultMacOsEnrollmentProfile *DepMacOSEnrollmentProfile `json:"defaultMacOsEnrollmentProfile,omitempty"`
	// EnrollmentProfiles undocumented
	EnrollmentProfiles []EnrollmentProfile `json:"enrollmentProfiles,omitempty"`
	// ImportedAppleDeviceIdentities undocumented
	ImportedAppleDeviceIdentities []ImportedAppleDeviceIdentity `json:"importedAppleDeviceIdentities,omitempty"`
}
