// Code generated by msgraph-generate.go DO NOT EDIT.

package msgraph

import (
	"context"
	"fmt"
	"io/ioutil"
	"net/http"

	"github.com/matterbridge/msgraph.go/jsonx"
)

// IntuneBrandingProfileRequestBuilder is request builder for IntuneBrandingProfile
type IntuneBrandingProfileRequestBuilder struct{ BaseRequestBuilder }

// Request returns IntuneBrandingProfileRequest
func (b *IntuneBrandingProfileRequestBuilder) Request() *IntuneBrandingProfileRequest {
	return &IntuneBrandingProfileRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// IntuneBrandingProfileRequest is request for IntuneBrandingProfile
type IntuneBrandingProfileRequest struct{ BaseRequest }

// Get performs GET request for IntuneBrandingProfile
func (r *IntuneBrandingProfileRequest) Get(ctx context.Context) (resObj *IntuneBrandingProfile, err error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	err = r.JSONRequest(ctx, "GET", query, nil, &resObj)
	return
}

// Update performs PATCH request for IntuneBrandingProfile
func (r *IntuneBrandingProfileRequest) Update(ctx context.Context, reqObj *IntuneBrandingProfile) error {
	return r.JSONRequest(ctx, "PATCH", "", reqObj, nil)
}

// Delete performs DELETE request for IntuneBrandingProfile
func (r *IntuneBrandingProfileRequest) Delete(ctx context.Context) error {
	return r.JSONRequest(ctx, "DELETE", "", nil, nil)
}

// Assignments returns request builder for IntuneBrandingProfileAssignment collection
func (b *IntuneBrandingProfileRequestBuilder) Assignments() *IntuneBrandingProfileAssignmentsCollectionRequestBuilder {
	bb := &IntuneBrandingProfileAssignmentsCollectionRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/assignments"
	return bb
}

// IntuneBrandingProfileAssignmentsCollectionRequestBuilder is request builder for IntuneBrandingProfileAssignment collection
type IntuneBrandingProfileAssignmentsCollectionRequestBuilder struct{ BaseRequestBuilder }

// Request returns request for IntuneBrandingProfileAssignment collection
func (b *IntuneBrandingProfileAssignmentsCollectionRequestBuilder) Request() *IntuneBrandingProfileAssignmentsCollectionRequest {
	return &IntuneBrandingProfileAssignmentsCollectionRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// ID returns request builder for IntuneBrandingProfileAssignment item
func (b *IntuneBrandingProfileAssignmentsCollectionRequestBuilder) ID(id string) *IntuneBrandingProfileAssignmentRequestBuilder {
	bb := &IntuneBrandingProfileAssignmentRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/" + id
	return bb
}

// IntuneBrandingProfileAssignmentsCollectionRequest is request for IntuneBrandingProfileAssignment collection
type IntuneBrandingProfileAssignmentsCollectionRequest struct{ BaseRequest }

// Paging perfoms paging operation for IntuneBrandingProfileAssignment collection
func (r *IntuneBrandingProfileAssignmentsCollectionRequest) Paging(ctx context.Context, method, path string, obj interface{}) ([]IntuneBrandingProfileAssignment, error) {
	req, err := r.NewJSONRequest(method, path, obj)
	if err != nil {
		return nil, err
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}
	res, err := r.client.Do(req)
	if err != nil {
		return nil, err
	}
	var values []IntuneBrandingProfileAssignment
	for {
		defer res.Body.Close()
		if res.StatusCode != http.StatusOK {
			b, _ := ioutil.ReadAll(res.Body)
			errRes := &ErrorResponse{Response: res}
			err := jsonx.Unmarshal(b, errRes)
			if err != nil {
				return nil, fmt.Errorf("%s: %s", res.Status, string(b))
			}
			return nil, errRes
		}
		var (
			paging Paging
			value  []IntuneBrandingProfileAssignment
		)
		err := jsonx.NewDecoder(res.Body).Decode(&paging)
		if err != nil {
			return nil, err
		}
		err = jsonx.Unmarshal(paging.Value, &value)
		if err != nil {
			return nil, err
		}
		values = append(values, value...)
		if len(paging.NextLink) == 0 {
			return values, nil
		}
		req, err = http.NewRequest("GET", paging.NextLink, nil)
		if ctx != nil {
			req = req.WithContext(ctx)
		}
		res, err = r.client.Do(req)
		if err != nil {
			return nil, err
		}
	}
}

// Get performs GET request for IntuneBrandingProfileAssignment collection
func (r *IntuneBrandingProfileAssignmentsCollectionRequest) Get(ctx context.Context) ([]IntuneBrandingProfileAssignment, error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	return r.Paging(ctx, "GET", query, nil)
}

// Add performs POST request for IntuneBrandingProfileAssignment collection
func (r *IntuneBrandingProfileAssignmentsCollectionRequest) Add(ctx context.Context, reqObj *IntuneBrandingProfileAssignment) (resObj *IntuneBrandingProfileAssignment, err error) {
	err = r.JSONRequest(ctx, "POST", "", reqObj, &resObj)
	return
}
