// Code generated by msgraph-generate.go DO NOT EDIT.

package msgraph

// RoleDefinition The Role Definition resource. The role definition is the foundation of role based access in Intune. The role combines an Intune resource such as a Mobile App and associated role permissions such as Create or Read for the resource. There are two types of roles, built-in and custom. Built-in roles cannot be modified. Both built-in roles and custom roles must have assignments to be enforced. Create custom roles if you want to define a role that allows any of the available resources and role permissions to be combined into a single role.
type RoleDefinition struct {
	// Entity is the base model of RoleDefinition
	Entity
	// DisplayName Display Name of the Role definition.
	DisplayName *string `json:"displayName,omitempty"`
	// Description Description of the Role definition.
	Description *string `json:"description,omitempty"`
	// Permissions List of Role Permissions this role is allowed to perform. These must match the actionName that is defined as part of the rolePermission.
	Permissions []RolePermission `json:"permissions,omitempty"`
	// RolePermissions List of Role Permissions this role is allowed to perform. These must match the actionName that is defined as part of the rolePermission.
	RolePermissions []RolePermission `json:"rolePermissions,omitempty"`
	// IsBuiltInRoleDefinition Type of Role. Set to True if it is built-in, or set to False if it is a custom role definition.
	IsBuiltInRoleDefinition *bool `json:"isBuiltInRoleDefinition,omitempty"`
	// IsBuiltIn Type of Role. Set to True if it is built-in, or set to False if it is a custom role definition.
	IsBuiltIn *bool `json:"isBuiltIn,omitempty"`
	// RoleScopeTagIDs List of Scope Tags for this Entity instance.
	RoleScopeTagIDs []string `json:"roleScopeTagIds,omitempty"`
	// RoleAssignments undocumented
	RoleAssignments []RoleAssignment `json:"roleAssignments,omitempty"`
}
