// Code generated by msgraph-generate.go DO NOT EDIT.

package msgraph

import (
	"context"
	"fmt"
	"io/ioutil"
	"net/http"

	"github.com/matterbridge/msgraph.go/jsonx"
)

// Windows10GeneralConfigurationRequestBuilder is request builder for Windows10GeneralConfiguration
type Windows10GeneralConfigurationRequestBuilder struct{ BaseRequestBuilder }

// Request returns Windows10GeneralConfigurationRequest
func (b *Windows10GeneralConfigurationRequestBuilder) Request() *Windows10GeneralConfigurationRequest {
	return &Windows10GeneralConfigurationRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// Windows10GeneralConfigurationRequest is request for Windows10GeneralConfiguration
type Windows10GeneralConfigurationRequest struct{ BaseRequest }

// Get performs GET request for Windows10GeneralConfiguration
func (r *Windows10GeneralConfigurationRequest) Get(ctx context.Context) (resObj *Windows10GeneralConfiguration, err error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	err = r.JSONRequest(ctx, "GET", query, nil, &resObj)
	return
}

// Update performs PATCH request for Windows10GeneralConfiguration
func (r *Windows10GeneralConfigurationRequest) Update(ctx context.Context, reqObj *Windows10GeneralConfiguration) error {
	return r.JSONRequest(ctx, "PATCH", "", reqObj, nil)
}

// Delete performs DELETE request for Windows10GeneralConfiguration
func (r *Windows10GeneralConfigurationRequest) Delete(ctx context.Context) error {
	return r.JSONRequest(ctx, "DELETE", "", nil, nil)
}

// PrivacyAccessControls returns request builder for WindowsPrivacyDataAccessControlItem collection
func (b *Windows10GeneralConfigurationRequestBuilder) PrivacyAccessControls() *Windows10GeneralConfigurationPrivacyAccessControlsCollectionRequestBuilder {
	bb := &Windows10GeneralConfigurationPrivacyAccessControlsCollectionRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/privacyAccessControls"
	return bb
}

// Windows10GeneralConfigurationPrivacyAccessControlsCollectionRequestBuilder is request builder for WindowsPrivacyDataAccessControlItem collection
type Windows10GeneralConfigurationPrivacyAccessControlsCollectionRequestBuilder struct{ BaseRequestBuilder }

// Request returns request for WindowsPrivacyDataAccessControlItem collection
func (b *Windows10GeneralConfigurationPrivacyAccessControlsCollectionRequestBuilder) Request() *Windows10GeneralConfigurationPrivacyAccessControlsCollectionRequest {
	return &Windows10GeneralConfigurationPrivacyAccessControlsCollectionRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// ID returns request builder for WindowsPrivacyDataAccessControlItem item
func (b *Windows10GeneralConfigurationPrivacyAccessControlsCollectionRequestBuilder) ID(id string) *WindowsPrivacyDataAccessControlItemRequestBuilder {
	bb := &WindowsPrivacyDataAccessControlItemRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/" + id
	return bb
}

// Windows10GeneralConfigurationPrivacyAccessControlsCollectionRequest is request for WindowsPrivacyDataAccessControlItem collection
type Windows10GeneralConfigurationPrivacyAccessControlsCollectionRequest struct{ BaseRequest }

// Paging perfoms paging operation for WindowsPrivacyDataAccessControlItem collection
func (r *Windows10GeneralConfigurationPrivacyAccessControlsCollectionRequest) Paging(ctx context.Context, method, path string, obj interface{}) ([]WindowsPrivacyDataAccessControlItem, error) {
	req, err := r.NewJSONRequest(method, path, obj)
	if err != nil {
		return nil, err
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}
	res, err := r.client.Do(req)
	if err != nil {
		return nil, err
	}
	var values []WindowsPrivacyDataAccessControlItem
	for {
		defer res.Body.Close()
		if res.StatusCode != http.StatusOK {
			b, _ := ioutil.ReadAll(res.Body)
			errRes := &ErrorResponse{Response: res}
			err := jsonx.Unmarshal(b, errRes)
			if err != nil {
				return nil, fmt.Errorf("%s: %s", res.Status, string(b))
			}
			return nil, errRes
		}
		var (
			paging Paging
			value  []WindowsPrivacyDataAccessControlItem
		)
		err := jsonx.NewDecoder(res.Body).Decode(&paging)
		if err != nil {
			return nil, err
		}
		err = jsonx.Unmarshal(paging.Value, &value)
		if err != nil {
			return nil, err
		}
		values = append(values, value...)
		if len(paging.NextLink) == 0 {
			return values, nil
		}
		req, err = http.NewRequest("GET", paging.NextLink, nil)
		if ctx != nil {
			req = req.WithContext(ctx)
		}
		res, err = r.client.Do(req)
		if err != nil {
			return nil, err
		}
	}
}

// Get performs GET request for WindowsPrivacyDataAccessControlItem collection
func (r *Windows10GeneralConfigurationPrivacyAccessControlsCollectionRequest) Get(ctx context.Context) ([]WindowsPrivacyDataAccessControlItem, error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	return r.Paging(ctx, "GET", query, nil)
}

// Add performs POST request for WindowsPrivacyDataAccessControlItem collection
func (r *Windows10GeneralConfigurationPrivacyAccessControlsCollectionRequest) Add(ctx context.Context, reqObj *WindowsPrivacyDataAccessControlItem) (resObj *WindowsPrivacyDataAccessControlItem, err error) {
	err = r.JSONRequest(ctx, "POST", "", reqObj, &resObj)
	return
}
