// Code generated by msgraph-generate.go DO NOT EDIT.

package msgraph

import (
	"context"
	"fmt"
	"io/ioutil"
	"net/http"

	"github.com/matterbridge/msgraph.go/jsonx"
)

// WorkbookRangeViewRequestBuilder is request builder for WorkbookRangeView
type WorkbookRangeViewRequestBuilder struct{ BaseRequestBuilder }

// Request returns WorkbookRangeViewRequest
func (b *WorkbookRangeViewRequestBuilder) Request() *WorkbookRangeViewRequest {
	return &WorkbookRangeViewRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// WorkbookRangeViewRequest is request for WorkbookRangeView
type WorkbookRangeViewRequest struct{ BaseRequest }

// Get performs GET request for WorkbookRangeView
func (r *WorkbookRangeViewRequest) Get(ctx context.Context) (resObj *WorkbookRangeView, err error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	err = r.JSONRequest(ctx, "GET", query, nil, &resObj)
	return
}

// Update performs PATCH request for WorkbookRangeView
func (r *WorkbookRangeViewRequest) Update(ctx context.Context, reqObj *WorkbookRangeView) error {
	return r.JSONRequest(ctx, "PATCH", "", reqObj, nil)
}

// Delete performs DELETE request for WorkbookRangeView
func (r *WorkbookRangeViewRequest) Delete(ctx context.Context) error {
	return r.JSONRequest(ctx, "DELETE", "", nil, nil)
}

// Rows returns request builder for WorkbookRangeView collection
func (b *WorkbookRangeViewRequestBuilder) Rows() *WorkbookRangeViewRowsCollectionRequestBuilder {
	bb := &WorkbookRangeViewRowsCollectionRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/rows"
	return bb
}

// WorkbookRangeViewRowsCollectionRequestBuilder is request builder for WorkbookRangeView collection
type WorkbookRangeViewRowsCollectionRequestBuilder struct{ BaseRequestBuilder }

// Request returns request for WorkbookRangeView collection
func (b *WorkbookRangeViewRowsCollectionRequestBuilder) Request() *WorkbookRangeViewRowsCollectionRequest {
	return &WorkbookRangeViewRowsCollectionRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// ID returns request builder for WorkbookRangeView item
func (b *WorkbookRangeViewRowsCollectionRequestBuilder) ID(id string) *WorkbookRangeViewRequestBuilder {
	bb := &WorkbookRangeViewRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/" + id
	return bb
}

// WorkbookRangeViewRowsCollectionRequest is request for WorkbookRangeView collection
type WorkbookRangeViewRowsCollectionRequest struct{ BaseRequest }

// Paging perfoms paging operation for WorkbookRangeView collection
func (r *WorkbookRangeViewRowsCollectionRequest) Paging(ctx context.Context, method, path string, obj interface{}) ([]WorkbookRangeView, error) {
	req, err := r.NewJSONRequest(method, path, obj)
	if err != nil {
		return nil, err
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}
	res, err := r.client.Do(req)
	if err != nil {
		return nil, err
	}
	var values []WorkbookRangeView
	for {
		defer res.Body.Close()
		if res.StatusCode != http.StatusOK {
			b, _ := ioutil.ReadAll(res.Body)
			errRes := &ErrorResponse{Response: res}
			err := jsonx.Unmarshal(b, errRes)
			if err != nil {
				return nil, fmt.Errorf("%s: %s", res.Status, string(b))
			}
			return nil, errRes
		}
		var (
			paging Paging
			value  []WorkbookRangeView
		)
		err := jsonx.NewDecoder(res.Body).Decode(&paging)
		if err != nil {
			return nil, err
		}
		err = jsonx.Unmarshal(paging.Value, &value)
		if err != nil {
			return nil, err
		}
		values = append(values, value...)
		if len(paging.NextLink) == 0 {
			return values, nil
		}
		req, err = http.NewRequest("GET", paging.NextLink, nil)
		if ctx != nil {
			req = req.WithContext(ctx)
		}
		res, err = r.client.Do(req)
		if err != nil {
			return nil, err
		}
	}
}

// Get performs GET request for WorkbookRangeView collection
func (r *WorkbookRangeViewRowsCollectionRequest) Get(ctx context.Context) ([]WorkbookRangeView, error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	return r.Paging(ctx, "GET", query, nil)
}

// Add performs POST request for WorkbookRangeView collection
func (r *WorkbookRangeViewRowsCollectionRequest) Add(ctx context.Context, reqObj *WorkbookRangeView) (resObj *WorkbookRangeView, err error) {
	err = r.JSONRequest(ctx, "POST", "", reqObj, &resObj)
	return
}
